/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2014-2024 Broadcom
 * All rights reserved.
 */

#ifndef ULP_HDR_FIELD_ENUMS_H_
#define ULP_HDR_FIELD_ENUMS_H_

enum bnxt_ulp_glb_hf {
	BNXT_ULP_GLB_HF_ID_WM,
	BNXT_ULP_GLB_HF_ID_SVIF_INDEX,
	BNXT_ULP_GLB_HF_ID_O_BTH_OP_CODE,
	BNXT_ULP_GLB_HF_ID_I_BTH_OP_CODE,
	BNXT_ULP_GLB_HF_ID_O_BTH_DST_QPN,
	BNXT_ULP_GLB_HF_ID_I_BTH_DST_QPN,
	BNXT_ULP_GLB_HF_ID_O_ECPRI_TYPE,
	BNXT_ULP_GLB_HF_ID_I_ECPRI_TYPE,
	BNXT_ULP_GLB_HF_ID_O_ECPRI_ID,
	BNXT_ULP_GLB_HF_ID_I_ECPRI_ID,
	BNXT_ULP_GLB_HF_ID_O_ETH_DMAC,
	BNXT_ULP_GLB_HF_ID_I_ETH_DMAC,
	BNXT_ULP_GLB_HF_ID_O_ETH_SMAC,
	BNXT_ULP_GLB_HF_ID_I_ETH_SMAC,
	BNXT_ULP_GLB_HF_ID_O_ETH_TYPE,
	BNXT_ULP_GLB_HF_ID_I_ETH_TYPE,
	BNXT_ULP_GLB_HF_ID_O_GENEVE_VER_OPT_LEN_O_C_RSVD0,
	BNXT_ULP_GLB_HF_ID_I_GENEVE_VER_OPT_LEN_O_C_RSVD0,
	BNXT_ULP_GLB_HF_ID_O_GENEVE_PROTO_TYPE,
	BNXT_ULP_GLB_HF_ID_I_GENEVE_PROTO_TYPE,
	BNXT_ULP_GLB_HF_ID_O_GENEVE_VNI,
	BNXT_ULP_GLB_HF_ID_I_GENEVE_VNI,
	BNXT_ULP_GLB_HF_ID_O_GENEVE_RSVD1,
	BNXT_ULP_GLB_HF_ID_I_GENEVE_RSVD1,
	BNXT_ULP_GLB_HF_ID_T_GRE_VER,
	BNXT_ULP_GLB_HF_ID_T_GRE_PROTO_TYPE,
	BNXT_ULP_GLB_HF_ID_O_ICMP_TYPE,
	BNXT_ULP_GLB_HF_ID_I_ICMP_TYPE,
	BNXT_ULP_GLB_HF_ID_O_ICMP_CODE,
	BNXT_ULP_GLB_HF_ID_I_ICMP_CODE,
	BNXT_ULP_GLB_HF_ID_O_ICMP_CSUM,
	BNXT_ULP_GLB_HF_ID_I_ICMP_CSUM,
	BNXT_ULP_GLB_HF_ID_O_ICMP_IDENT,
	BNXT_ULP_GLB_HF_ID_I_ICMP_IDENT,
	BNXT_ULP_GLB_HF_ID_O_ICMP_SEQ_NUM,
	BNXT_ULP_GLB_HF_ID_I_ICMP_SEQ_NUM,
	BNXT_ULP_GLB_HF_ID_O_IPV4_VER,
	BNXT_ULP_GLB_HF_ID_I_IPV4_VER,
	BNXT_ULP_GLB_HF_ID_O_IPV4_QOS,
	BNXT_ULP_GLB_HF_ID_I_IPV4_QOS,
	BNXT_ULP_GLB_HF_ID_O_IPV4_LEN,
	BNXT_ULP_GLB_HF_ID_I_IPV4_LEN,
	BNXT_ULP_GLB_HF_ID_O_IPV4_FRAG_ID,
	BNXT_ULP_GLB_HF_ID_I_IPV4_FRAG_ID,
	BNXT_ULP_GLB_HF_ID_O_IPV4_FRAG_OFF,
	BNXT_ULP_GLB_HF_ID_I_IPV4_FRAG_OFF,
	BNXT_ULP_GLB_HF_ID_O_IPV4_TTL,
	BNXT_ULP_GLB_HF_ID_I_IPV4_TTL,
	BNXT_ULP_GLB_HF_ID_O_IPV4_PROTO_ID,
	BNXT_ULP_GLB_HF_ID_I_IPV4_PROTO_ID,
	BNXT_ULP_GLB_HF_ID_O_IPV4_CSUM,
	BNXT_ULP_GLB_HF_ID_I_IPV4_CSUM,
	BNXT_ULP_GLB_HF_ID_O_IPV4_SRC_ADDR,
	BNXT_ULP_GLB_HF_ID_I_IPV4_SRC_ADDR,
	BNXT_ULP_GLB_HF_ID_O_IPV4_DST_ADDR,
	BNXT_ULP_GLB_HF_ID_I_IPV4_DST_ADDR,
	BNXT_ULP_GLB_HF_ID_O_IPV6_VER,
	BNXT_ULP_GLB_HF_ID_I_IPV6_VER,
	BNXT_ULP_GLB_HF_ID_O_IPV6_QOS,
	BNXT_ULP_GLB_HF_ID_I_IPV6_QOS,
	BNXT_ULP_GLB_HF_ID_O_IPV6_FLOW_LABEL,
	BNXT_ULP_GLB_HF_ID_I_IPV6_FLOW_LABEL,
	BNXT_ULP_GLB_HF_ID_O_IPV6_PAYLOAD_LEN,
	BNXT_ULP_GLB_HF_ID_I_IPV6_PAYLOAD_LEN,
	BNXT_ULP_GLB_HF_ID_O_IPV6_PROTO_ID,
	BNXT_ULP_GLB_HF_ID_I_IPV6_PROTO_ID,
	BNXT_ULP_GLB_HF_ID_O_IPV6_TTL,
	BNXT_ULP_GLB_HF_ID_I_IPV6_TTL,
	BNXT_ULP_GLB_HF_ID_O_IPV6_SRC_ADDR,
	BNXT_ULP_GLB_HF_ID_I_IPV6_SRC_ADDR,
	BNXT_ULP_GLB_HF_ID_O_IPV6_DST_ADDR,
	BNXT_ULP_GLB_HF_ID_I_IPV6_DST_ADDR,
	BNXT_ULP_GLB_HF_ID_O_L2_FILTER_L2_FILTER_ID,
	BNXT_ULP_GLB_HF_ID_I_L2_FILTER_L2_FILTER_ID,
	BNXT_ULP_GLB_HF_ID_O_SRV6_NEXT_HDR,
	BNXT_ULP_GLB_HF_ID_I_SRV6_NEXT_HDR,
	BNXT_ULP_GLB_HF_ID_O_SRV6_HDR_LEN,
	BNXT_ULP_GLB_HF_ID_I_SRV6_HDR_LEN,
	BNXT_ULP_GLB_HF_ID_O_SRV6_ROUTING_TYPE,
	BNXT_ULP_GLB_HF_ID_I_SRV6_ROUTING_TYPE,
	BNXT_ULP_GLB_HF_ID_O_SRV6_SEG_LEFT,
	BNXT_ULP_GLB_HF_ID_I_SRV6_SEG_LEFT,
	BNXT_ULP_GLB_HF_ID_O_SRV6_LAST_ENTRY,
	BNXT_ULP_GLB_HF_ID_I_SRV6_LAST_ENTRY,
	BNXT_ULP_GLB_HF_ID_O_SRV6_FLAGS,
	BNXT_ULP_GLB_HF_ID_I_SRV6_FLAGS,
	BNXT_ULP_GLB_HF_ID_O_SRV6_TAG,
	BNXT_ULP_GLB_HF_ID_I_SRV6_TAG,
	BNXT_ULP_GLB_HF_ID_O_TCP_SRC_PORT,
	BNXT_ULP_GLB_HF_ID_I_TCP_SRC_PORT,
	BNXT_ULP_GLB_HF_ID_O_TCP_DST_PORT,
	BNXT_ULP_GLB_HF_ID_I_TCP_DST_PORT,
	BNXT_ULP_GLB_HF_ID_O_TCP_SENT_SEQ,
	BNXT_ULP_GLB_HF_ID_I_TCP_SENT_SEQ,
	BNXT_ULP_GLB_HF_ID_O_TCP_RECV_ACK,
	BNXT_ULP_GLB_HF_ID_I_TCP_RECV_ACK,
	BNXT_ULP_GLB_HF_ID_O_TCP_DATA_OFF,
	BNXT_ULP_GLB_HF_ID_I_TCP_DATA_OFF,
	BNXT_ULP_GLB_HF_ID_O_TCP_TCP_FLAGS,
	BNXT_ULP_GLB_HF_ID_I_TCP_TCP_FLAGS,
	BNXT_ULP_GLB_HF_ID_O_TCP_RX_WIN,
	BNXT_ULP_GLB_HF_ID_I_TCP_RX_WIN,
	BNXT_ULP_GLB_HF_ID_O_TCP_CSUM,
	BNXT_ULP_GLB_HF_ID_I_TCP_CSUM,
	BNXT_ULP_GLB_HF_ID_O_TCP_URP,
	BNXT_ULP_GLB_HF_ID_I_TCP_URP,
	BNXT_ULP_GLB_HF_ID_O_UDP_SRC_PORT,
	BNXT_ULP_GLB_HF_ID_I_UDP_SRC_PORT,
	BNXT_ULP_GLB_HF_ID_O_UDP_DST_PORT,
	BNXT_ULP_GLB_HF_ID_I_UDP_DST_PORT,
	BNXT_ULP_GLB_HF_ID_O_UDP_LENGTH,
	BNXT_ULP_GLB_HF_ID_I_UDP_LENGTH,
	BNXT_ULP_GLB_HF_ID_O_UDP_CSUM,
	BNXT_ULP_GLB_HF_ID_I_UDP_CSUM,
	BNXT_ULP_GLB_HF_ID_OO_VLAN_CFI_PRI,
	BNXT_ULP_GLB_HF_ID_OI_VLAN_CFI_PRI,
	BNXT_ULP_GLB_HF_ID_IO_VLAN_CFI_PRI,
	BNXT_ULP_GLB_HF_ID_II_VLAN_CFI_PRI,
	BNXT_ULP_GLB_HF_ID_OO_VLAN_VID,
	BNXT_ULP_GLB_HF_ID_OI_VLAN_VID,
	BNXT_ULP_GLB_HF_ID_IO_VLAN_VID,
	BNXT_ULP_GLB_HF_ID_II_VLAN_VID,
	BNXT_ULP_GLB_HF_ID_OO_VLAN_TYPE,
	BNXT_ULP_GLB_HF_ID_OI_VLAN_TYPE,
	BNXT_ULP_GLB_HF_ID_IO_VLAN_TYPE,
	BNXT_ULP_GLB_HF_ID_II_VLAN_TYPE,
	BNXT_ULP_GLB_HF_ID_T_VXLAN_FLAGS,
	BNXT_ULP_GLB_HF_ID_T_VXLAN_RSVD0,
	BNXT_ULP_GLB_HF_ID_T_VXLAN_VNI,
	BNXT_ULP_GLB_HF_ID_T_VXLAN_RSVD1,
	BNXT_ULP_GLB_HF_ID_T_VXLAN_GPE_FLAGS,
	BNXT_ULP_GLB_HF_ID_T_VXLAN_GPE_RSVD0,
	BNXT_ULP_GLB_HF_ID_T_VXLAN_GPE_NEXT_PROTO,
	BNXT_ULP_GLB_HF_ID_T_VXLAN_GPE_VNI,
	BNXT_ULP_GLB_HF_ID_T_VXLAN_GPE_RSVD1
};

#endif
